/*
 * Universidade Federal de Pernambuco - UFPE
 * Centro de Informtica - CIn
 * Centro Integrado de Tecnologia da Informao - CITi
 * Curso de C/C++
 * Autor: Allan Lima - http://allanlima.wordpress.com/
 * Instrutor: Luiz Felipe Sotero (lfss@cin.ufpe.br)
 *
 * exemploPonteiroFuncao.c - Exemplos de como utilizar ponteiros para funes.
 *
 *
 * Exemplo retirado do curso de C da ufmg
 * http://ead1.eee.ufmg.br/cursos/C/
 */

#include <stdio.h>
#include <string.h>

void PrintString(char *str, int (*func)(const char *)) {
	(*func)(str); // chamada a funo atravs do ponteiro para funo

	// maneira tambm vlida de se fazer a chamada a funo atravs do
	// ponteiro para funo func
	func(str);

}
/*
int main () {
	char String [20]="Curso de C/C++";

	// Declaracao do ponteiro para funo Funcao apontada  inteira e recebe
	// como parametro uma string constante
	int (*p)(const char *);

	// O ponteiro p passa a apontar para a funo puts
	// que tem o seguinte prototipo: int puts(const char *)
	p=puts;
    p(String);
	PrintString (String, p); // O ponteiro  passado como parametro para PrintString
	return 0;
}
*/
